unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants,
  Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls, ComCtrls,
  ExtCtrls,registry;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    StatusBar1: TStatusBar;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    SaveDialog: TSaveDialog;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Timer: TTimer;
    procedure N4Click(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure N7Click(Sender: TObject);
    procedure N9Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure N10Click(Sender: TObject);
    procedure forminit;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TReadThread=class(TThread)
    procedure Execute;override;
    end;


var
  Form1: TForm1;

implementation

uses Unit2,Unit3;

{$R *.dfm}

var dwwrite:dword;
    Buf: array[0..65536] of Byte;
    buf2:array[0..7] of Byte;
    csvbuf: array[0..65536] of Byte;
    csvcount:integer;
    hport:integer;
    dcb: TDcb;
    thr:TReadThread;
    comstr:string;
    portmode:integer;
    eventcount:integer;

var   OverRead: TOverlapped;
      OverWrite: TOverlapped;

function az(v:integer):string;
begin
if v<10 then result:='0'+inttostr(v) else result:=inttostr(v);
end;

function getbit(v,b:integer):string;
begin
if (v and (1 shl b))>0 then
   result:='1'
else
   result:='0'; 
end;

function time2buf:string;
var dt:TDateTime;
    STime: TSystemTime;
    y:integer;
begin
DateTimeToSystemTime(now,STime);
y:=stime.wYear mod 100;
buf2[6]:=y;
buf2[5]:=stime.wMonth;
buf2[4]:=stime.wDay;
buf2[3]:=stime.wHour;
buf2[2]:=stime.wMinute;
buf2[1]:=stime.wSecond;
result:=az(y)+az(stime.wMonth)+az(stime.wday)+'_'+az(stime.wHour)+az(stime.wMinute)+az(stime.wSecond)+'.csv';
end;

procedure TForm1.N7Click(Sender: TObject);
begin
if (application.messagebox('   ?','',MB_YESNO+MB_ICONQUESTION)=IDYES) then
  begin
  buf2[0]:=$20;
  writefile(hPort, Buf2, 1, dwwrite, @overwrite);
  end;
end;

procedure TForm1.N10Click(Sender: TObject);
begin
if (application.messagebox('    ?','',MB_YESNO+MB_ICONQUESTION)=IDYES) then
  begin
  buf2[0]:=$11;
  time2buf;
  writefile(hPort, Buf2, 7,dwwrite, @overwrite);
  end;
end;

var csv:textfile;

procedure TForm1.N6Click(Sender: TObject);
begin
savedialog.FileName:=time2buf;
if savedialog.Execute then
  begin
  timer.Enabled:=false;
  assignfile(csv,savedialog.FileName);
  rewrite(csv);

  portmode:=2;
  csvcount:=0;
  buf2[0]:=$22;
  writefile(hPort, Buf2, 1, dwwrite, @overwrite);
  end;
end;


procedure initport;
begin
hPort := CreateFile(pchar(comstr), GENERIC_READ or GENERIC_WRITE, 0, nil, OPEN_EXISTING, FILE_FLAG_OVERLAPPED, 0);
if hPort = INVALID_HANDLE_VALUE then
   begin
   showmessage('Error opening port');
   exit;
   end;

if not GetCommState(hPort, Dcb) then
   begin
   showmessage('Error setting port state');
   exit;
   end;

//Dcb.BaudRate := CBR_9600;
Dcb.BaudRate := CBR_19200;
Dcb.Parity := NOPARITY;
Dcb.ByteSize := 8;
Dcb.StopBits := ONESTOPBIT;
if not SetCommState(hPort, Dcb) then
   begin
   showmessage('Error setting port state');
   exit;
   end;


if not PurgeComm(hPort, PURGE_TXCLEAR or PURGE_RXCLEAR) then
   begin
   showmessage('Error purging port');
   exit;
   end;

if not SetCommMask(hPort, EV_RXCHAR) then
   begin
   showmessage('Error setting port mask');
   exit;
   end;

EscapeCommFunction(hport,SETRTS);

thr:=TReadThread.Create(false);
end;

procedure doneport;
begin
if (thr<>nil) then thr.Suspend;
CloseHandle(hport);
end;

procedure TReadThread.Execute;
var
  ComStat: TComStat;
  dwMask, dwError: DWORD;
  dwRead,dwReaded: DWORD;
  k:integer;
  s:string;
begin
OverRead.hEvent := CreateEvent(nil, True, False, nil);
if OverRead.hEvent = Null then
   raise Exception.Create('Error creating read event');

Overwrite.hEvent := CreateEvent(nil, True, False, nil);
if Overwrite.hEvent = Null then
   raise Exception.Create('Error creating write event');


FreeOnTerminate := True;

while not Terminated do
  begin

  if not WaitCommEvent(hPort, dwMask, @OverRead) then
    begin
    if GetLastError = ERROR_IO_PENDING then WaitForSingleObject(OverRead.hEvent, INFINITE)
    else raise Exception.Create('Error waiting port event');
    end;
    
if not ClearCommError(hPort, dwError, @ComStat) then raise Exception.Create('Error clearing port');
dwRead := ComStat.cbInQue;
if dwRead > 0 then
  begin
  if not ReadFile(hPort, Buf, dwRead, dwRead, @OverRead) then
    raise Exception.Create('Error reading port');
//  Buf   
//     
    if portmode=1 then
       begin//cur_time
//       if (buf[0]=$4f) and (buf[1]=$4b) then
         if (dwRead=8) then
          begin
          eventcount:=integer(buf[6]) shl 8 + buf[7];
          form1.label1.Caption:=inttostr(eventcount);
          form1.label2.Caption:=az(buf[2])+':'+az(buf[1])+':'+az(buf[0]);
          form1.label3.Caption:=az(buf[3])+'.'+az(buf[4])+'.'+az(buf[5]);
          form1.StatusBar1.Panels[2].Text:=' ';
          Form1.StatusBar1.Panels[1].Text:='';
          end
       else
           begin
           form1.label1.Caption:='---';
           form1.label2.Caption:='---';
           form1.StatusBar1.Panels[2].Text:='  ';
          Form1.StatusBar1.Panels[1].Text:='';           
           end;
       end
    else
       begin//data
       s:=options.edit2.text;
       for k:=0 to dwread-1 do
           begin
           csvbuf[csvcount]:=buf[k];
           inc(csvcount);
           end;
       Form1.StatusBar1.Panels[1].Text:=inttostr(100*csvcount div (eventcount*8))+'%';
       Form1.StatusBar1.Panels[2].Text:=' ';
       if (csvcount=eventcount*8) then
          begin
          for k:=0 to eventcount-1 do
              writeln(csv,az(csvbuf[8*k+2])+s+az(csvbuf[8*k+1])+s+az(csvbuf[8*k+0])+s+
                    az(csvbuf[8*k+3])+s+az(csvbuf[8*k+4])+s+az(csvbuf[8*k+5])+s+
                    getbit(csvbuf[8*k+6],0)+s+getbit(csvbuf[8*k+6],1)+s+getbit(csvbuf[8*k+6],2)+s+getbit(csvbuf[8*k+6],3));

          closefile(csv);
          form1.timer.Enabled:=true;
          end;
       end;

  end;
  end; {while}
end;

procedure TForm1.TimerTimer(Sender: TObject);
begin
//timer event
//  buf2[0]:=$54;
  buf2[1]:=$21;
  buf2[0]:=$10;
  writefile(hPort, Buf2, 2, dwwrite, @overwrite);
  portmode:=1;
end;

// -----------config-----------------

procedure loadreg;
var Reg: TRegistry;
begin
 Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CURRENT_USER;
    if Reg.OpenKey('\Software\ExOS\logger',false) then
       begin
       options.cb1.ItemIndex:=reg.ReadInteger('port');
       options.cb2.ItemIndex:=reg.ReadInteger('time');
       options.Edit2.Text:=reg.ReadString('sep');
       Reg.CloseKey;
       end;
  finally
    Reg.Free;
  end;
end;

procedure savereg;
var Reg: TRegistry;
begin
 Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CURRENT_USER;
    if Reg.OpenKey('\Software\ExOS\logger',True) then
       begin
       Reg.WriteInteger('port',options.cb1.ItemIndex);
       Reg.WriteInteger('time',options.cb2.ItemIndex);
       Reg.writeString('sep',options.Edit2.Text);
       Reg.CloseKey;
       end;

  finally
    Reg.Free;
  end;
end;

procedure applyconfig;
begin
case options.cb2.itemindex of
     0:form1.timer.interval:=1000;
     1:form1.timer.interval:=5000;
     2:form1.timer.interval:=10000;
     3:form1.timer.interval:=30000;
     4:form1.timer.interval:=60000;
     end;
comstr:='COM'+inttostr(options.cb1.itemindex+1);
form1.statusbar1.panels[0].Text:=comstr;
end;

// -----------inteface-----------------

procedure TForm1.N5Click(Sender: TObject);
begin
if options.ShowModal=id_ok then
   begin
   form1.Timer.Enabled:=false;
   savereg;
   doneport;
   applyconfig;
   initport;
   form1.timer.Enabled:=true;
   end;
end;

procedure TForm1.forminit;
begin
   loadreg;
   applyconfig;
   initport;
   form1.timer.Enabled:=true;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
doneport;
end;

procedure TForm1.N9Click(Sender: TObject);
begin
close;
end;

procedure TForm1.N4Click(Sender: TObject);
begin
AboutBox.showmodal;
end;

end.
